<?php

$block_name = _("Comics");

/**
 * $Horde: klutz/lib/Block/summary.php,v 1.20 2004/12/01 16:56:34 jan Exp $
 *
 * @package Horde_Block
 */
class Horde_Block_Klutz_summary extends Horde_Block {

    var $_app = 'klutz';

    /**
     * The title to go in this block.
     *
     * @return string   The title text.
     */
    function _title()
    {
        global $registry;

        $title = Horde::link(Horde::applicationUrl('comics.php'), $registry->get('name'));
        $title .= $registry->get('name') . '</a> :: ';
        $linkurl = Util::addParameter(Horde::applicationUrl('comics.php'), array('actionID' => 'day', 'date' => mktime(0, 0, 0)));
        $title .= Horde::link($linkurl, _("Today's Comics"), 'smallheader');
        $title .= ' ' . _("Today") . '</a>';

        return $title;
    }

    /**
     * The content to go in this block.
     *
     * @return string   The content
     */
    function _content()
    {
        require_once dirname(__FILE__) . '/../base.php';
        global $prefs, $klutz, $storage;

        $showall = $prefs->getValue('summ_showall');
        $date = time();

        // Get the list of comics to display.
        $comics = explode("\t", $prefs->getValue('viewcomics'));
        if (count($comics) == 1 && empty($comics[0])) {
            $comics = null;
        }

        $comicstoday = $klutz->listEnabled($comics, $date);

        if ($showall) {
            $summary = '<table border="0">';
            foreach ($comicstoday as $index) {
                $name = $klutz->getProperty($index, 'name');
                $author = $klutz->getProperty($index, 'author');
                if ($storage->imageExists($index, $date)) {
                    $size = $storage->imageSize($index, $date);
                    $url = Util::addParameter(Horde::applicationUrl('comics.php'), array('date' => $date, 'index' => $index));
                    $img = Horde::img(Util::addParameter($url, 'actionID', 'image'), sprintf("%s by %s", $name, $author), $size, '');
                    $link = Horde::link(Util::addParameter($url, 'actionID', 'comic'), sprintf("%s by %s", $name, $author));
                    $summary .= '<tr><td>' . $link . $img . '</a></td></tr>';
                }
            }
            $summary .= '</table>';
        } else {
            // Pick a comic from the list and make sure it exists.
            do {
                // Make sure we actually have some comics to choose
                // from.
                if (count($comicstoday) == 0) {
                    return _("Could not find any comics to display.");
                }

                // Pick a comic by random and remove it from the list.
                $i = rand(0, count($comicstoday) - 1);
                $index = array_shift(array_splice($comicstoday, $i, 1));
            } while ($storage->imageExists($index, $date) === false);

            $name = $klutz->getProperty($index, 'name');
            $author = $klutz->getProperty($index, 'author');
            $size = $storage->imageSize($index, $date);
            $url = Util::addParameter(Horde::applicationUrl('comics.php'), array('date' => $date, 'index' => $index));
            $img = Horde::img(Util::addParameter($url, 'actionID', 'image'), sprintf("%s by %s", $name, $author), $size, '');
            $link = Horde::link(Util::addParameter($url, 'actionID', 'comic'), sprintf("%s by %s", $name, $author));
            $summary  = '<table border="0"><tr><td class="text">' . $link . $name . ' by ' . $author . '</a></td></tr>';
            $summary .= '<tr><td>' . $link . $img . '</a></td></tr></table>';
        }

        return $summary;
    }

}
